题目描述
给你一个整数数组 nums
。如果数字 x
在数组中仅出现 一次 ,且没有 相邻 数字(即,x + 1
和 x - 1
)出现在数组中,则认为数字 x
是 孤独数字 。
返回 nums
中的 所有 孤独数字。你可以按 任何顺序 返回答案。
示例 1:
输入:nums = [10,6,5,8]
输出:[10,8]
解释:
- 10 是一个孤独数字,因为它只出现一次,并且 9 和 11 没有在 nums 中出现。
- 8 是一个孤独数字,因为它只出现一次,并且 7 和 9 没有在 nums 中出现。
- 5 不是一个孤独数字,因为 6 出现在 nums 中,反之亦然。
因此,nums 中的孤独数字是 [10, 8] 。
注意,也可以返回 [8, 10] 。
示例 2:
输入:nums = [1,3,5,3]
输出:[1,5]
解释:
- 1 是一个孤独数字,因为它只出现一次,并且 0 和 2 没有在 nums 中出现。
- 5 是一个孤独数字,因为它只出现一次,并且 4 和 6 没有在 nums 中出现。
- 3 不是一个孤独数字,因为它出现两次。
因此,nums 中的孤独数字是 [1, 5] 。
注意,也可以返回 [5, 1] 。
提示:
1 <= nums.length <= 105
0 <= nums[i] <= 106
解法
方法一:哈希表
我们用一个哈希表 $\textit{cnt}$ 记录每个数字出现的次数,然后遍历哈希表,对于每个数字及其出现次数 $(x, v)$,如果 $v = 1$ 且 $\textit{cnt}[x - 1] = 0$ 且 $\textit{cnt}[x + 1] = 0$,则 $x$ 是一个孤独数字,将其加入答案数组中。
遍历结束后,返回答案数组即可。
时间复杂度 $O(n)$,空间复杂度 $O(n)$。其中 $n$ 为数组 $\textit{nums}$ 的长度。
| class Solution:
def findLonely(self, nums: List[int]) -> List[int]:
cnt = Counter(nums)
return [
x for x, v in cnt.items() if v == 1 and cnt[x - 1] == 0 and cnt[x + 1] == 0
]
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16 | class Solution {
public List<Integer> findLonely(int[] nums) {
Map<Integer, Integer> cnt = new HashMap<>();
for (int x : nums) {
cnt.merge(x, 1, Integer::sum);
}
List<Integer> ans = new ArrayList<>();
for (var e : cnt.entrySet()) {
int x = e.getKey(), v = e.getValue();
if (v == 1 && !cnt.containsKey(x - 1) && !cnt.containsKey(x + 1)) {
ans.add(x);
}
}
return ans;
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16 | class Solution {
public:
vector<int> findLonely(vector<int>& nums) {
unordered_map<int, int> cnt;
for (int x : nums) {
cnt[x]++;
}
vector<int> ans;
for (auto& [x, v] : cnt) {
if (v == 1 && !cnt.contains(x - 1) && !cnt.contains(x + 1)) {
ans.push_back(x);
}
}
return ans;
}
};
|
1
2
3
4
5
6
7
8
9
10
11
12 | func findLonely(nums []int) (ans []int) {
cnt := map[int]int{}
for _, x := range nums {
cnt[x]++
}
for x, v := range cnt {
if v == 1 && cnt[x-1] == 0 && cnt[x+1] == 0 {
ans = append(ans, x)
}
}
return
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13 | function findLonely(nums: number[]): number[] {
const cnt: Map<number, number> = new Map();
for (const x of nums) {
cnt.set(x, (cnt.get(x) || 0) + 1);
}
const ans: number[] = [];
for (const [x, v] of cnt) {
if (v === 1 && !cnt.has(x - 1) && !cnt.has(x + 1)) {
ans.push(x);
}
}
return ans;
}
|